//
// Copyright (C) 2023 - Dassault Systemes - Bruno JOFRET
//


function demo_new_colormaps()

    colormapList = ["Blues", "Greens", "Greys", "Oranges", "Purples", "Reds",...
    "BuGn", "BuPu", "GnBu", "OrRd", "PuBu", "PuBuGn", "PuRd", "RdPu", "YlGn", "YlGnBu", "YlOrBr", "YlOrRd", ...
    "BrBG", "PiYG", "PRGn", "PuOr", "RdBu", "RdGy", "RdYlBu", "RdYlGn", "Spectral", "coolwarm"];

    //Compute gigantic colormap
    cmap=[];
    for i=colormapList
        cmap = [cmap ; colormap(i)]
    end

    n = size(colormapList, '*');
    M = zeros(128, n);
    M(:) = 1:size(M, '*');
    M = M'

    f=scf();
    Matplot(M)
    f.color_map = cmap;
    a=gca();
    a.axes_visible = ["off", "on", "off"];
    a.auto_ticks = "off";
    y_ticks = a.y_ticks;
    y_ticks.locations = (1:size(colormapList, '*'))'
    y_ticks.labels = colormapList($:-1:1)';
    a.y_ticks = y_ticks;
    a.sub_ticks = [0 0]
endfunction

demo_new_colormaps();
clear demo_new_colormaps;
